/*---------------------------------------------------------------------------
 * libpr.c Ver1.0
 * ʎpCu
 *
 * Last update : 1998/10/20
 *
 * Copyright(C) 1997-98  Yuto Ikeno  All rights reserved.
 * e-mail : mew@onbiz.net
 * homepage:http://www.onbiz.net/~mew/
 * compile: gcc -c libpr.c
----------------------------------------------------------------------------*/

/*--- Include ---*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpr.h"

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint delline (char *, unsigned int)
@@@@Fchar *filename	ΏۂƂȂt@C
@@@@@@@unsigned int 		zXg
@@@@Fw肳ꂽt@C̎ws폜
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int delline(char *fName, unsigned int lNumber){

	FILE	*fp;
	int		i;
	int		count = 0;
	char	**buf2Dim;

	if((fp = fopen(fName, "r")) == NULL)
		return 1;
	for(i = 0;  ; i++){
		if((*(buf2Dim + i) = fgetLine(fp)) == NULL)
			break;
	}
	fclose(fp);

	count = i + 1;

	if((fp = fopen(fName, "w")) == NULL)
		return 1;
	for (i = 0; i < count ; i++){
		if((i + 1) != lNumber)
			fputs(*(buf2Dim + i),fp);
	}
	fclose(fp);
	freeTwoDimArray(buf2Dim, count);

	return 0;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint addline (char *, char *)
@@@@Fchar *filename		ΏۂƂȂt@C
@@@@@@@char *host_name 		zXg
@@@@Fw肳ꂽt@Cɍڂǉ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int addline(char *filename, char *host_name){

	FILE	*fp;
	int		i;

	if((fp = fopen(filename, "a")) == NULL)
		return 1;

	fprintf(fp,"%s\n",host_name);
	fclose(fp);

	return 0;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid freeTwoDimArray(char **, unsigned int)
@@@@Fchar **Array			񎟔zւ̃|C^
@@@@@@@unsigned int lines	񎟔z̔z
@@@@FIɊmۂꂽ񎟔zArraySĉ܂B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void freeTwoDimArray(char **Array, unsigned int lines){

	unsigned int	i;

	for(i = 0; i < lines; i++){
		if(*(Array + i))
			free(*(Array + 1));
	}
	free(Array);

	return ;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *fgetLine(FILE *);
@@@@FFILE *rfp		ǂݍރt@Cւ̃|C^
Ԃl@@@@char *		ǂݍ񂾂Ps
@@@@@@@@@@@@@@t@C̏ȈꍇNULL
@@@@FrfpŎw肳ꂽt@CPsǂݍ݁A̕i[
@@@@@@@̈ւ̃|C^ԂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *fgetLine(FILE *rfp){

	char	buf[BUFSIZE];
	char	*tmp;
	char	*tmp2;

	tmp = (char *)malloc(sizeof(char) * 2);
	*tmp = '\0';

	while(1){
		if(fgets(buf, BUFSIZE, rfp) == NULL){
			if(feof(rfp)){
				if(*tmp == '\0')
					return NULL;
			}
		}
		tmp2 = (char *)malloc(strlen(tmp) + strlen(buf) + 1);
		sprintf(tmp2, "%s%s", tmp, buf);
		free(tmp);
		tmp = (char *)malloc(strlen(tmp2) + 1);
		strcpy(tmp, tmp2);
		free(tmp2);
		if(isNewLine(buf))
			break;
		if(feof(rfp))
			break;
	}

	return tmp;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFunsigned int countFileLine(const char *)
@@@@Fconst char *fName		JEgt@C
߂l@@@Funsigned int			Yt@C̍s
@@@@FfNnameŎw肳ꂽt@C̍sJEg
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
unsigned int countFileLine(const char *fName){

	char			buf[BUFSIZE];
	unsigned int	lines = 0;
	FILE			*rfp;
	
	if((rfp = fopen(fName, "r")) == NULL)
		fatal_error("t@C̃I[vɎs܂B()", "<BODY>");

	while(1){
		if(fgets(buf, BUFSIZE, rfp) == NULL){
			break;
		}else{
			if(strstr(buf, "\n") != NULL)
				lines++;
		}
	}

	fclose(rfp);

	return lines;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar **readFile(const char *, unsigned int)
@@@@Fconst char *fName		ǂݍރt@C
@@@@@@@unsigned int lines	ǂݍރt@C̍s
߂l@@@Fchar **				Yt@C̓ei[񎟔z
@@@@FfNameŎw肳ꂽt@Clinessǂݍ݁Aei[
@@@@@@@zւ̃|C^ԂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char **readFile(const char *fName, unsigned int lines){

	char			buf[BUFSIZE];
	char			**bufRead;
	FILE			*rfp;
	unsigned int	i;

	if((rfp = fopen(fName, "r")) == NULL)
		fatal_error("t@C̃I[vɎs܂B(readFile()-1)", "<BODY>");

	bufRead = (char **)malloc(sizeof(char *) * lines);
	for (i = 0; i < lines; i++){
		if(fgets(buf, BUFSIZE, rfp) == NULL)
			break;
		*(bufRead + i) = (char *)malloc(strlen(buf) + 1);
		strcpy(*(bufRead + i), buf);
	}
	fclose(rfp);

	return bufRead;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid removeNewline (char *)
@@@@Fchar *obj		ΏۂƂȂ镶
@@@@FobjCRA܂LF݂ꍇoĂ_ŕ؂
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void removeNewline(char *obj){

	char	*p = obj;	/*obj̈ʒuۑ*/

	while(*obj){
		if(*obj != 0x0a && *obj != 0x0d)
			obj++;		
		else
			*obj = '\0';
	}
	obj = p;	/*ʒu*/

	return;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint isNewLine(char *);
@@@@Fchar *str		`FbN镶
Ԃl@@@@int			0Fs݂Ȃ
@@@@@@@@@@@@@@1Fs݂
@@@@Fstrɉs݂邩ǂׂ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int isNewLine(char *str){

	char	*s = str;

	while(*str){
		if(*str == 0x0a || *str == 0x0d){
			str = s;
			return 1;
		}
		str++;
	}
	str = s;
	return 0;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint addLineTop(const char *, const char *);
@@@@Fconst char *fName		ރt@C
@@@@@@@const char *str		ޓe
Ԃl@@@@int				0:I
@@@@@@@					1:ُI
@@@@FfpŎw肳t@C̐擪ɂPsistrjށB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int addLineTop(const char *fName, const char *str){

	unsigned int	i;
	char			**bufRead;
	FILE			*wfp;
	unsigned int	count;

	count = countFileLine(fName);
	bufRead = readFile(fName, count);

	if((wfp = fopen(fName, "w")) == NULL)
		return 1;

	fprintf(wfp, "%s\n" ,str);
	for(i = 0; i < count; i++)
		fputs(*(bufRead + i), wfp);

	fclose(wfp);
	freeTwoDimArray(bufRead, count);

	return 0;
}
